unit leoufscarfoc;

{$mode objfpc}{$H+}

interface

type
  Tcoord = Record
    npol:integer;
    xi:real;
    yi:real;
  end;


function Ncd1(x1,y1,x2,y2,ymax,x,y,fcd,xEpsilonC2,ffcnNconcreto:Real):Real;
function Mcd1xx(x1,y1,x2,y2,ymax,x,y,fcd,xEpsilonC2,ffcnNconcreto:Real):Real;
function Mcd1yy(x1,y1,x2,y2,ymax,x,y,fcd,xEpsilonC2,ffcnNconcreto:Real):Real;
function Ncd2(x1,y1,x2,y2,y,fcd:Real):Real;
function Mcd2xx(x1,y1,x2,y2,y,fcd:Real):Real;
function Mcd2yy(x1,y1,x2,y2,y,fcd:Real):Real;
procedure ObterCaractGeomet(const Coord:array of Tcoord; var fpAc,fpxcg, fpycg:real);
procedure TranslacaoDePontos(const Coord:array of Tcoord; var fpxcg,fpycg:real;var CoordT:array of Tcoord);
procedure RotacaoDePontos(const Angulo:real;Coord:array of Tcoord; var CoordR:array of TCoord);
procedure PontosMaximoMinimo(const Coord:array of Tcoord;var fpvmax,fpvmin:real);
function TensaoArmPas(var varEpsilonS,varEs,varfyd:Real):real;
function TensaoArmAtiv(var varEpsilonpyd,varEpsilonpu,varfpyd,varfptd,varEpsilont:Real):real;
function ForcaConcreto(Poligono:array of Tcoord;ffcnfcd,ffcnxalfa,ffcnxEpsilonC2,ffcnNconcreto:real):real;
function MomentoXXConcreto(Poligono:array of Tcoord;ffcnfcd,ffcnxalfa,ffcnxEpsilonC2,ffcnNconcreto:real):real;
function MomentoYYConcreto(Poligono:array of Tcoord;ffcnfcd,ffcnxalfa,ffcnxEpsilonC2,ffcnNconcreto:real):real;

implementation

function Ncd1(x1,y1,x2,y2,ymax,x,y,fcd,xEpsilonC2,ffcnNconcreto:Real):Real;
var
ffuncc,ffuncd,ffunce:real;

begin
  if y1<>y2 then // Todas as condições já excluem a chance de y1=y2, aqui é possível criar uma faixa de segurança, y1/y2>0,0001, por ex
     begin
       ffuncc:=((y1*x2-y2*x1)/(y1-y2));
       ffuncd:=((x1-x2)/(y1-y2));
     end;
  if y1=y2 then // Todas as condições já excluem a chance de y1=y2, mesmo assim, é melhor prevenir, criando uma certa seguranca y1/y2>0,0001, por ex
    begin
       ffuncc:=0;
       ffuncd:=0;
     end;
   if (((ymax-x)+xEpsilonC2-y)/xEpsilonC2)<=0 then ffunce:=0; // Isto é, logaritmo neperiano de um numero extremamente pequeno - mas maior e diferente de zero!
   if (((ymax-x)+xEpsilonC2-y)/xEpsilonC2)>0 then ffunce:=exp(ln(((ymax-x)+xEpsilonC2-y)/xEpsilonC2)*(ffcnNconcreto+1)); // Rodar a função!


  Result:=-0.85*fcd*(-(xEpsilonC2*ffunce*(ffuncc*(ffcnNconcreto+2)+ffuncd*((ymax-x)+xEpsilonC2+ffcnNconcreto*y+y)))
  /((ffcnNconcreto+1)*(ffcnNconcreto+2))
    -ffuncc*y-(ffuncd*y*y)/2);
end;


function Mcd1xx(x1,y1,x2,y2,ymax,x,y,fcd,xEpsilonC2,ffcnNconcreto:Real):Real;

var
ffuncc,ffuncd,ffunce:real;

begin
  if y1<>y2 then // Todas as condições já excluem a chance de y1=y2, aqui é possível criar uma faixa de segurança, y1/y2>0,0001, por ex
     begin
       ffuncc:=((y1*x2-y2*x1)/(y1-y2));
       ffuncd:=((x1-x2)/(y1-y2));
     end;
  if y1=y2 then // Todas as condições já excluem a chance de y1=y2, aqui é possível criar uma faixa de segurança, y1/y2>0,0001, por ex
    begin
       ffuncc:=0;
       ffuncd:=0;
     end;
   if (((ymax-x)+xEpsilonC2-y)/xEpsilonC2)<=0 then ffunce:=0; // Isto é, logaritmo neperiano de um numero extremamente pequeno - mas maior e diferente de zero!
   if (((ymax-x)+xEpsilonC2-y)/xEpsilonC2)>0 then ffunce:=exp(ln(((ymax-x)+xEpsilonC2-y)/xEpsilonC2)*(ffcnNconcreto+1)); // Rodar a função!


  Result:=(0.85*fcd*(3*ffuncc*((1+ffcnNconcreto)*(2+ffcnNconcreto)*
          (3+ffcnNconcreto)*y*y+2*xEpsilonC2*ffunce*(((ymax-x)+xEpsilonC2)*
          (3+ffcnNconcreto)+(3+4*ffcnNconcreto+ffcnNconcreto*ffcnNconcreto)*y))+
          2*ffuncd*((1+ffcnNconcreto)*(2+ffcnNconcreto)*(3+ffcnNconcreto)*y*y*y+
          3*xEpsilonC2*ffunce*(2*(ymax-x)*(ymax-x)+2*xEpsilonC2*xEpsilonC2+
          2*xEpsilonC2*(1+ffcnNconcreto)*y+
          (2+3*ffcnNconcreto+ffcnNconcreto*ffcnNconcreto)*y*y
          +2*(ymax-x)*(2*xEpsilonC2+(1+ffcnNconcreto)*y)))))
          /(6*(1+ffcnNconcreto)*(2+ffcnNconcreto)*(3+ffcnNconcreto))
          ;
end;


function Mcd1yy(x1,y1,x2,y2,ymax,x,y,fcd,xEpsilonC2,ffcnNconcreto:Real):Real;
var
ffuncc,ffuncd,ffunce:real;

begin

   if y1<>y2 then // Todas as condições já excluem a chance de y1=y2, aqui é possível criar uma faixa de segurança, y1/y2>0,0001, por ex
     begin
       ffuncc:=((y1*x2-y2*x1)/(y1-y2));
       ffuncd:=((x1-x2)/(y1-y2));
     end;
  if y1=y2 then // Todas as condições já excluem a chance de y1=y2, aqui é possível criar uma faixa de segurança, y1/y2>0,0001, por ex
    begin
       ffuncc:=0;
       ffuncd:=0;
     end;
   if (((ymax-x)+xEpsilonC2-y)/xEpsilonC2)<=0 then ffunce:=0; // Isto é, logaritmo neperiano de um numero extremamente pequeno - mas maior e diferente de zero!
   if (((ymax-x)+xEpsilonC2-y)/xEpsilonC2)>0 then ffunce:=exp(ln(((ymax-x)+xEpsilonC2-y)/xEpsilonC2)*(ffcnNconcreto+1)); // Rodar a função!

  Result:=(0.85*fcd*(3*ffuncc*ffuncc*(xEpsilonC2*
  (6+5*ffcnNconcreto+ffcnNconcreto*ffcnNconcreto)*ffunce+
  (1+ffcnNconcreto)*(2+ffcnNconcreto)*(3+ffcnNconcreto)*y)+
  3*ffuncc*ffuncd*((1+ffcnNconcreto)*(2+ffcnNconcreto)*(3+ffcnNconcreto)*y*y+
  2*xEpsilonC2*ffunce*(((ymax-x)+xEpsilonC2)*(3+ffcnNconcreto)+
  (3+4*ffcnNconcreto+ffcnNconcreto*ffcnNconcreto)*y))+
  ffuncd*ffuncd*((1+ffcnNconcreto)*(2+ffcnNconcreto)*(3+ffcnNconcreto)*y*y*y+
  3*xEpsilonC2*ffunce*(2*(ymax-x)*(ymax-x)+
  2*xEpsilonC2*xEpsilonC2+2*xEpsilonC2*(1+ffcnNconcreto)*y+
  (2+3*ffcnNconcreto+ffcnNconcreto*ffcnNconcreto)*y*y+
  2*(ymax-x)*(2*xEpsilonC2+(1+ffcnNconcreto)*y)))))/
  (6*(1+ffcnNconcreto)*(2+ffcnNconcreto)*(3+ffcnNconcreto))

  ;


end;

function Ncd2(x1,y1,x2,y2,y,fcd:Real):Real;
var
ffuncc,ffuncd:real;

begin

   if y1<>y2 then // Todas as condições já excluem a chance de y1=y2, aqui é possível criar uma faixa de segurança, y1/y2>0,0001, por ex
     begin
       ffuncc:=((y1*x2-y2*x1)/(y1-y2));
       ffuncd:=((x1-x2)/(y1-y2));
     end;
  if y1=y2 then // Todas as condições já excluem a chance de y1=y2, aqui é possível criar uma faixa de segurança, y1/y2>0,0001, por ex
    begin
       ffuncc:=0;
       ffuncd:=0;
     end;
  Result:=0.85*fcd*y*(ffuncc+ffuncd*y/2);


end;

function Mcd2xx(x1,y1,x2,y2,y,fcd:Real):Real;
var
ffuncc,ffuncd:real;

begin

   if y1<>y2 then // Todas as condições já excluem a chance de y1=y2, aqui é possível criar uma faixa de segurança, y1/y2>0,0001, por ex
     begin
       ffuncc:=((y1*x2-y2*x1)/(y1-y2));
       ffuncd:=((x1-x2)/(y1-y2));
     end;
  if y1=y2 then // Todas as condições já excluem a chance de y1=y2, aqui é possível criar uma faixa de segurança, y1/y2>0,0001, por ex
    begin
       ffuncc:=0;
       ffuncd:=0;
     end;
   Result:=0.85*fcd*(ffuncc*y*y/2+ffuncd*y*y*y/3)
  ;


end;

function Mcd2yy(x1,y1,x2,y2,y,fcd:Real):Real;
var
ffuncc,ffuncd:real;

begin

   if y1<>y2 then // Todas as condições já excluem a chance de y1=y2, aqui é possível criar uma faixa de segurança, y1/y2>0,0001, por ex
     begin
       ffuncc:=((y1*x2-y2*x1)/(y1-y2));
       ffuncd:=((x1-x2)/(y1-y2));
     end;
  if y1=y2 then // Todas as condições já excluem a chance de y1=y2, aqui é possível criar uma faixa de segurança, y1/y2>0,0001, por ex
    begin
       ffuncc:=0;
       ffuncd:=0;
     end;

  Result:=0.85*fcd*(ffuncc*ffuncc*y+ffuncc*ffuncd*y*y+ffuncd*ffuncd*y*y*y/3)/2
  ;


end;

procedure ObterCaractGeomet(const Coord:array of Tcoord; var fpAc,fpxcg, fpycg:real);
var
fSxx,fSyy:real;
fContador:integer;

begin
     fpAc:=0;
     fSxx:=0;
     fSyy:=0;

     for fContador:=0 to Length(Coord)-2 do
     begin
         fpAc:=fpAc+Coord[fContador].xi*Coord[fContador+1].yi-Coord[fContador+1].xi*Coord[fContador].yi;
         fSxx:=fSxx+(Coord[fContador].xi*Coord[fContador+1].yi-Coord[fContador+1].xi*Coord[fContador].yi)*(Coord[fContador].yi+Coord[fContador+1].yi);
         fSyy:=fSyy+(Coord[fContador].xi*Coord[fContador+1].yi-Coord[fContador+1].xi*Coord[fContador].yi)*(Coord[fContador].xi+Coord[fContador+1].xi);
     end;

     fpAc:=fpAc/2;
     fSxx:=fSxx/6;
     fSyy:=fSyy/6;
     fpxcg:=fSyy/fpAc;
     fpycg:=fSxx/fpAc;
end;

procedure TranslacaoDePontos(const Coord:array of Tcoord; var fpxcg,fpycg:real;var CoordT:array of Tcoord);
var
  fContador:integer;

begin
     for fContador:=0 to Length(Coord)-1 do
     begin
         CoordT[fContador].xi:=Coord[fContador].xi-fpxcg;
         CoordT[fContador].yi:=Coord[fContador].yi-fpycg;
         CoordT[fContador].npol:=Coord[fContador].npol;

     end;
end;

procedure RotacaoDePontos(const Angulo:real;Coord:array of Tcoord; var CoordR:array of TCoord);
var
iContador:integer;

   begin
     for iContador:=0 to Length(Coord)-1 do
         begin
             CoordR[iContador].xi:=Coord[iContador].xi*cos(Angulo*pi/180)-Coord[iContador].yi*sin(Angulo*pi/180);
             CoordR[iContador].yi:=Coord[iContador].xi*sin(Angulo*pi/180)+Coord[iContador].yi*cos(Angulo*pi/180);
             CoordR[iContador].npol:=Coord[iContador].npol;
         end;

   end;

procedure PontosMaximoMinimo(const Coord:array of Tcoord;var fpvmax,fpvmin:real);
var
iContador:integer;

  begin
    fpvmax:=Coord[0].yi;
    fpvmin:=Coord[0].yi;
    for iContador:=1 to Length(Coord)-1 do
        begin
            if Coord[iContador].yi>fpvmax then
               fpvmax:=Coord[iContador].yi;
            if Coord[iContador].yi<fpvmin then
               fpvmin:=Coord[iContador].yi;
        end;
  end;

function TensaoArmPas(var varEpsilonS,varEs,varfyd:Real):real;
begin
     if varEpsilonS<=varfyd/varEs*1000 then  //Trabalhando apenas antes da ruptura por compressão
        begin
        TensaoArmPas:=-varfyd;
          if varEpsilonS>=-varfyd/varEs*1000 then
            begin
              TensaoArmPas:=varEs*varEpsilonS/1000;
            end;

        end;

     if varEpsilonS>=varfyd/varEs*1000 then
        begin
          TensaoArmPas:=varfyd;
        end;
end;

function TensaoArmAtiv(var varEpsilonpyd,varEpsilonpu,varfpyd,varfptd,varEpsilont:Real):real;


begin
  Result:=0;
  if varEpsilont<0 then //Lembrar: negativo e tração; e positivo compressao
    begin
      if varEpsilont>=varEpsilonpyd then
        begin
          Result:=varEpsilont*varfpyd/varEpsilonpyd;
        end;
      if varEpsilont<varEpsilonpyd then
        begin
          Result:=varfpyd+(varfptd-varfpyd)/(varEpsilonpu-varEpsilonpyd)*(varEpsilont-varEpsilonpyd);
        end;
    end;
end;

function ForcaConcreto(Poligono:array of Tcoord;ffcnfcd,ffcnxalfa,ffcnxEpsilonC2,ffcnNconcreto:real):real;
var
fcnConcContador:integer;
ffcnvmax,ffcnvmin:real;

begin
  Result:=0;
  ffcnvmax:=0;
  ffcnvmin:=0;
  PontosMaximoMinimo(Poligono,ffcnvmax,ffcnvmin);
  for fcnConcContador:=0 to Length(Poligono)-2 do // Inicio do calculo das forças no concreto
            begin
                if abs(Poligono[fcnConcContador].yi-Poligono[fcnConcContador+1].yi)>0.000001 then // Medida para evitar travar o programa com (Y1 = Y2) que acarreta ( Denominador = Zero )
                   begin

                      if Poligono[fcnConcContador].yi<Poligono[fcnConcContador+1].yi then // Primeiro ponto MENOR que segundo

                                begin
                                    if Poligono[fcnConcContador].yi<ffcnvmax-ffcnxalfa then //Primeiro Ponto Em tração
                                      begin
                                         if Poligono[fcnConcContador+1].yi<=ffcnvmax-ffcnxalfa then
                                           begin
                                              // Se segundo ponto em tração, fazer nada
                                           end;


                                         if Poligono[fcnConcContador+1].yi>ffcnvmax-ffcnxalfa then  // Segundo ponto numa área comprimida
                                           begin
                                              if Poligono[fcnConcContador+1].yi<=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then // Segundo ponto na denominada area 1
                                                begin
                                                  Result:=Result
                                                          +Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador+1].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                          -Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto);
                                                end;
                                              if Poligono[fcnConcContador+1].yi>ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then   // Segundo ponto na denominada area de compressão 2
                                                begin
                                                  Result:=Result
                                                          +Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                          -Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                          +Ncd2(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador+1].yi,ffcnfcd)
                                                          -Ncd2(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd);
                                                end;
                                           end;




                                      end;
                                //Primeiro Ponto na primeira área de compressão
                                      if Poligono[fcnConcContador].yi<ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then
                                        begin
                                          if Poligono[fcnConcContador].yi>=ffcnvmax-ffcnxalfa then
                                            begin

                                              if Poligono[fcnConcContador+1].yi<=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then // Segundo ponto na denominada area 1
                                              begin
                                                Result:=Result
                                                         +Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador+1].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                         -Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto);
                                              end;

                                              if Poligono[fcnConcContador+1].yi>ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then // Segundo ponto na denominada area 2
                                                begin
                                                Result:=Result
                                                         +Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                         -Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                         +Ncd2(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador+1].yi,ffcnfcd)
                                                         -Ncd2(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd);
                                                end;


                                            end;
                                        end;

                                if Poligono[fcnConcContador].yi>=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then//Primeiro Ponto na segunda área de compressão
                                  begin
                                                         Result:=Result
                                                         +Ncd2(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador+1].yi,ffcnfcd)
                                                         -Ncd2(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador].yi,ffcnfcd);


                                  end;

                             end; // Fim de (Primeiro ponto Menor que segundo ponto)

                             if Poligono[fcnConcContador+1].yi<Poligono[fcnConcContador].yi then // Segundo ponto MENOR que primeiro ponto
                               begin

                                 if Poligono[fcnConcContador].yi<=ffcnvmax-ffcnxalfa then //Primeiro Ponto Em tração
                                   begin
                                      // Nada a fazer
                                   end;

                                  if Poligono[fcnConcContador].yi<=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then //Primeiro Ponto na primeira área de compressão
                                    begin

                                       if Poligono[fcnConcContador].yi>ffcnvmax-ffcnxalfa then  //Primeiro ponto na primeira area de compressão - condição 2
                                         begin

                                           if Poligono[fcnConcContador+1].yi>ffcnvmax-ffcnxalfa then // Segundo ponto na denominada area 1
                                             begin
                                              Result:=Result
                                                       +Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador+1].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                       -Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto);
                                             end;

                                           if Poligono[fcnConcContador+1].yi<=ffcnvmax-ffcnxalfa then // Segundo ponto na area de tração
                                              begin
                                                Result:=Result
                                                              +Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                              -Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto);
                                              end;



                                         end;
                                    end;

                                  if Poligono[fcnConcContador].yi>ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then //Primeiro Ponto na segunda área de compressão
                                    begin

                                      if Poligono[fcnConcContador+1].yi>=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then //Segundo ponto na segunda área de compressão
                                        begin
                                          Result:=Result
                                                   +Ncd2(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador+1].yi,ffcnfcd)
                                                   -Ncd2(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador].yi,ffcnfcd);


                                        end;

                                      if Poligono[fcnConcContador+1].yi<ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then //Segundo ponto na primeira área de compressão
                                        begin
                                          if Poligono[fcnConcContador+1].yi>=ffcnvmax-ffcnxalfa then //Segundo ponto na primeira área de compressão - condição 2
                                            begin
                                              Result:=Result
                                                         +Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador+1].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                         -Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                         +Ncd2(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd)
                                                         -Ncd2(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador].yi,ffcnfcd);

                                            end;
                                        end;

                                      if Poligono[fcnConcContador+1].yi<ffcnvmax-ffcnxalfa then // Segundo ponto na area tracionada
                                        begin
                                          Result:=Result
                                                         +Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                         -Ncd1(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                         +Ncd2(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd)
                                                         -Ncd2(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador].yi,ffcnfcd);
                                        end;

                                    end;

                                 end; // Final dos calculos com segundo ponto menor que o primeiro para compressão do concreto
                   end;



                  end; // Fim do calculo das forças no concreto
end;
// Força concreto - Fim

function MomentoXXConcreto(Poligono:array of Tcoord;ffcnfcd,ffcnxalfa,ffcnxEpsilonC2,ffcnNconcreto:real):real;
var
fcnConcContador:integer;
ffcnvmax,ffcnvmin:real;

begin

               Result:=0;
               ffcnvmax:=0;
               ffcnvmin:=0;

               PontosMaximoMinimo(Poligono,ffcnvmax,ffcnvmin);

               for fcnConcContador:=0 to Length(Poligono)-2 do // Inicio do calculo do momento xx no concreto
                  begin
                      if abs(Poligono[fcnConcContador].yi-Poligono[fcnConcContador+1].yi)>0.000001 then // Medida para evitar travar o programa com (Y1 = Y2) que acarreta ( Denominador = Zero )
                        begin

                             if Poligono[fcnConcContador].yi<Poligono[fcnConcContador+1].yi then // Primeiro ponto MENOR que segundo

                                begin
                                    if Poligono[fcnConcContador].yi<ffcnvmax-ffcnxalfa then //Primeiro Ponto Em tração
                                      begin
                                         if Poligono[fcnConcContador+1].yi<=ffcnvmax-ffcnxalfa then
                                           begin
                                              // Se segundo ponto em tração, fazer nada
                                           end;


                                         if Poligono[fcnConcContador+1].yi>ffcnvmax-ffcnxalfa then  // Segundo ponto numa área comprimida
                                           begin
                                              if Poligono[fcnConcContador+1].yi<=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then // Segundo ponto na denominada area 1
                                                begin
                                                  Result:=Result
                                                          +Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador+1].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                          -Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto);
                                                end;
                                              if Poligono[fcnConcContador+1].yi>ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then   // Segundo ponto na denominada area de compressão 2
                                                begin
                                                  Result:=Result
                                                          +Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                          -Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                          +Mcd2xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador+1].yi,ffcnfcd)
                                                          -Mcd2xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd);
                                                end;
                                           end;




                                      end;
                                //Primeiro Ponto na primeira área de compressão
                                      if Poligono[fcnConcContador].yi<ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then
                                        begin
                                          if Poligono[fcnConcContador].yi>=ffcnvmax-ffcnxalfa then
                                            begin

                                              if Poligono[fcnConcContador+1].yi<=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then // Segundo ponto na denominada area 1
                                              begin
                                                Result:=Result
                                                         +Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador+1].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                         -Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto);
                                              end;

                                              if Poligono[fcnConcContador+1].yi>ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then // Segundo ponto na denominada area 2
                                                begin
                                                Result:=Result
                                                         +Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                         -Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                         +Mcd2xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador+1].yi,ffcnfcd)
                                                         -Mcd2xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd);
                                                end;


                                            end;
                                        end;

                                if Poligono[fcnConcContador].yi>=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then//Primeiro Ponto na segunda área de compressão
                                  begin
                                                         Result:=Result
                                                         +Mcd2xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador+1].yi,ffcnfcd)
                                                         -Mcd2xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador].yi,ffcnfcd);


                                  end;

                             end; // Fim de (Primeiro ponto Menor que segundo ponto)

                             if Poligono[fcnConcContador+1].yi<Poligono[fcnConcContador].yi then // Segundo ponto MENOR que primeiro ponto
                               begin

                                 if Poligono[fcnConcContador].yi<=ffcnvmax-ffcnxalfa then //Primeiro Ponto Em tração
                                   begin
                                      // Nada a fazer
                                   end;

                                  if Poligono[fcnConcContador].yi<=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then //Primeiro Ponto na primeira área de compressão
                                    begin

                                       if Poligono[fcnConcContador].yi>ffcnvmax-ffcnxalfa then  //Primeiro ponto na primeira area de compressão - condição 2
                                         begin

                                           if Poligono[fcnConcContador+1].yi>ffcnvmax-ffcnxalfa then // Segundo ponto na denominada area 1
                                             begin
                                              Result:=Result
                                                       +Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador+1].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                       -Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto);
                                             end;

                                           if Poligono[fcnConcContador+1].yi<=ffcnvmax-ffcnxalfa then // Segundo ponto na area de tração
                                              begin
                                                Result:=Result
                                                              +Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                              -Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto);
                                              end;



                                         end;
                                    end;

                                  if Poligono[fcnConcContador].yi>ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then //Primeiro Ponto na segunda área de compressão
                                    begin

                                      if Poligono[fcnConcContador+1].yi>=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then //Segundo ponto na segunda área de compressão
                                        begin
                                          Result:=Result
                                                   +Mcd2xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador+1].yi,ffcnfcd)
                                                   -Mcd2xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador].yi,ffcnfcd);


                                        end;

                                      if Poligono[fcnConcContador+1].yi<ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then //Segundo ponto na primeira área de compressão
                                        begin
                                          if Poligono[fcnConcContador+1].yi>=ffcnvmax-ffcnxalfa then //Segundo ponto na primeira área de compressão - condição 2
                                            begin
                                              Result:=Result
                                                         +Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador+1].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                         -Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                         +Mcd2xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd)
                                                         -Mcd2xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador].yi,ffcnfcd);

                                            end;
                                        end;

                                      if Poligono[fcnConcContador+1].yi<ffcnvmax-ffcnxalfa then // Segundo ponto na area tracionada
                                        begin
                                          Result:=Result
                                                         +Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                         -Mcd1xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                         +Mcd2xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd)
                                                         -Mcd2xx(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador].yi,ffcnfcd);
                                        end;

                                    end;

                                 end; // Final dos calculos com segundo ponto menor que o primeiro para compressão do concreto
                             end;
                        end;// Fim do calculo do momento Mxx no concreto

end;


function MomentoYYConcreto(Poligono:array of Tcoord;ffcnfcd,ffcnxalfa,ffcnxEpsilonC2,ffcnNconcreto:real):real;
var
fcnConcContador:integer;
ffcnvmax,ffcnvmin:real;

begin

     Result:=0;
     ffcnvmax:=0;
     ffcnvmin:=0;

     PontosMaximoMinimo(Poligono,ffcnvmax,ffcnvmin);
     for fcnConcContador:=0 to Length(Poligono)-2 do // Inicio do calculo do momento yy no concreto
                begin

                    if abs(Poligono[fcnConcContador].yi-Poligono[fcnConcContador+1].yi)>0.000001 then // Medida para evitar travar o programa com (Y1 = Y2) que acarreta ( Denominador = Zero )
                      begin
                           if Poligono[fcnConcContador].yi<Poligono[fcnConcContador+1].yi then // Primeiro ponto MENOR que segundo

                              begin
                                  if Poligono[fcnConcContador].yi<ffcnvmax-ffcnxalfa then //Primeiro Ponto Em tração
                                    begin
                                       if Poligono[fcnConcContador+1].yi<=ffcnvmax-ffcnxalfa then
                                         begin
                                            // Se segundo ponto em tração, fazer nada
                                         end;


                                       if Poligono[fcnConcContador+1].yi>ffcnvmax-ffcnxalfa then  // Segundo ponto numa área comprimida
                                         begin
                                            if Poligono[fcnConcContador+1].yi<=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then // Segundo ponto na denominada area 1
                                              begin
                                                Result:=Result
                                                        +Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador+1].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                        -Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto);
                                              end;
                                            if Poligono[fcnConcContador+1].yi>ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then   // Segundo ponto na denominada area de compressão 2
                                              begin
                                                Result:=Result
                                                        +Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                        -Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                        +Mcd2yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador+1].yi,ffcnfcd)
                                                        -Mcd2yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd);
                                              end;
                                         end;




                                    end;
                              //Primeiro Ponto na primeira área de compressão
                                    if Poligono[fcnConcContador].yi<ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then
                                      begin
                                        if Poligono[fcnConcContador].yi>=ffcnvmax-ffcnxalfa then
                                          begin

                                            if Poligono[fcnConcContador+1].yi<=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then // Segundo ponto na denominada area 1
                                            begin
                                              Result:=Result
                                                       +Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador+1].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                       -Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto);
                                            end;

                                            if Poligono[fcnConcContador+1].yi>ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then // Segundo ponto na denominada area 2
                                              begin
                                              Result:=Result
                                                       +Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                       -Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                       +Mcd2yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador+1].yi,ffcnfcd)
                                                       -Mcd2yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd);
                                              end;


                                          end;
                                      end;

                              if Poligono[fcnConcContador].yi>=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then//Primeiro Ponto na segunda área de compressão
                                begin
                                                       Result:=Result
                                                       +Mcd2yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador+1].yi,ffcnfcd)
                                                       -Mcd2yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador].yi,ffcnfcd);


                                end;

                           end; // Fim de (Primeiro ponto Menor que segundo ponto)

                           if Poligono[fcnConcContador+1].yi<Poligono[fcnConcContador].yi then // Segundo ponto MENOR que primeiro ponto
                             begin

                               if Poligono[fcnConcContador].yi<=ffcnvmax-ffcnxalfa then //Primeiro Ponto Em tração
                                 begin
                                    // Nada a fazer
                                 end;

                                if Poligono[fcnConcContador].yi<=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then //Primeiro Ponto na primeira área de compressão
                                  begin

                                     if Poligono[fcnConcContador].yi>ffcnvmax-ffcnxalfa then  //Primeiro ponto na primeira area de compressão - condição 2
                                       begin

                                         if Poligono[fcnConcContador+1].yi>ffcnvmax-ffcnxalfa then // Segundo ponto na denominada area 1
                                           begin
                                            Result:=Result
                                                     +Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador+1].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                     -Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto);
                                           end;

                                         if Poligono[fcnConcContador+1].yi<=ffcnvmax-ffcnxalfa then // Segundo ponto na area de tração
                                            begin
                                              Result:=Result
                                                            +Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                            -Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto);
                                            end;



                                       end;
                                  end;

                                if Poligono[fcnConcContador].yi>ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then //Primeiro Ponto na segunda área de compressão
                                  begin

                                    if Poligono[fcnConcContador+1].yi>=ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then //Segundo ponto na segunda área de compressão
                                      begin
                                        Result:=Result
                                                 +Mcd2yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador+1].yi,ffcnfcd)
                                                 -Mcd2yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador].yi,ffcnfcd);


                                      end;

                                    if Poligono[fcnConcContador+1].yi<ffcnvmax-ffcnxalfa+ffcnxEpsilonC2 then //Segundo ponto na primeira área de compressão
                                      begin
                                        if Poligono[fcnConcContador+1].yi>=ffcnvmax-ffcnxalfa then //Segundo ponto na primeira área de compressão - condição 2
                                          begin
                                            Result:=Result
                                                       +Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,Poligono[fcnConcContador+1].yi,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                       -Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                       +Mcd2yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd)
                                                       -Mcd2yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador].yi,ffcnfcd);

                                          end;
                                      end;

                                    if Poligono[fcnConcContador+1].yi<ffcnvmax-ffcnxalfa then // Segundo ponto na area tracionada
                                      begin
                                        Result:=Result
                                                       +Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                       -Mcd1yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax,ffcnxalfa,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd,ffcnxEpsilonC2,ffcnNconcreto)
                                                       +Mcd2yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,ffcnvmax-ffcnxalfa+ffcnxEpsilonC2,ffcnfcd)
                                                       -Mcd2yy(Poligono[fcnConcContador].xi,Poligono[fcnConcContador].yi,Poligono[fcnConcContador+1].xi,Poligono[fcnConcContador+1].yi,Poligono[fcnConcContador].yi,ffcnfcd);
                                      end;

                                  end;

                               end; // Final dos calculos com segundo ponto menor que o primeiro para compressão do concreto
                           end;

                      end; // Fim do calculo do momento yy no concreto
end;



end.

